<?php

# config
$upload_path = 'uploads/';

# FUNCTIONS
function save_data($file, $data){
	
	# 1. DECODE?
	switch (@$_POST['encode']){
		case 'null': #1-3% !
			require_once('null_encode.php');
			$data = null_decode($data);
			break;
		case 'base91': #23%
			require_once('base91.php');
			$data = base91_decode($data);
			break;
		case 'base64': #33%
			$data = base64_decode($data);
			break;
			
//		case 'yenc': #2-3% !
//			require_once('yenc.php');
//			$data = yenc_decode($data);
//			break;
//		case 'ascii85': # 25%
//			require_once('ascii85.php');
//			$data = ascii85_decode($data);
//			break;
//		case 'uuencode': #25%
//			$data = convert_uudecode($data);
//			break;
//		case 'binhex':
//			# TODO
//			break;
	}

	# 2. DECRYPT?
	switch (@$_POST['encrypt']){
		case 'aes':
			require_once('aes.php');
			$data = aes_decrypt_string($data, 'abcdefghijklnmop', 128);
			break;
		case 'xor':
      require_once('xor.php');
      $data = xor_decrypt_string($data, 'abcdefghijklnmop');
			break;
	}
	
	# 3. DECOMPRESS?
	switch (@$_POST['compress']){
		case 'zlib':
			#$data = gzuncompress($data);
			$data = gzinflate($data);
			break;
			
//		case 'rle':
//      # TODO
//			break;
	}
	
	# 4. SAVE
	return file_put_contents($file, $data);
}

if (!function_exists('file_put_contents')){
function file_put_contents($file, $str) {
  $f=fopen($file, 'wb');
  fwrite($f, $str);
  fclose($f);
}
}

# START

$ret = 'OK';
if (isset($_POST['data'])){
	
	$data = $_POST['data'];
	if (get_magic_quotes_gpc()) $data = stripslashes($data);

	$filename = basename($_POST['filename']);
	$ziel_file = $upload_path . $filename;
		
	if (isset($_POST["chunk_num"])){ # CHUNKED TRANSFER
		@session_start();
		
		if ($_POST['chunk_num']=='1'){
			$_SESSION['chunk_count'] = $_POST['chunk_count'];
			$_SESSION['chunks'] = array();
			$_SESSION['filename'] = basename($_POST['filename']);
			
			@unlink($_SESSION['filename']);
			@unlink($_SESSION['filename'].'.tmp');
			
			$ret = session_name() .','. session_id();
		}
		
		$fp = fopen($ziel_file.'.tmp', 'ab');
		fwrite($fp, $data);
		fclose($fp);

		$_SESSION['chunks'][$_POST['chunk_num']] = 1;

		if (count($_SESSION['chunks']) >= $_SESSION['chunk_count']){
			$data = file_get_contents($ziel_file.'.tmp');
			save_data($ziel_file, $data);
			@unlink($ziel_file.'.tmp');
		}
		
	}else{
		save_data($ziel_file, $data);
	}
	
	echo $ret;
}

?>