<?php

if (!function_exists('file_put_contents')){
	function file_put_contents($file, $string) {
	  $f=fopen($file, 'w');
	  fwrite($f, $string);
	  fclose($f);
	}
}

# STRING #######################
function xor_encrypt_string($content, $key)
{
	$ret = '';
	$strLen = strlen($content);
	$keyLen = strlen($key);
	for ($i=0;$i<$strLen;$i++){
		$c = $content{$i};
		$kc = $key{$i%$keyLen};
		$ret .= chr(ord($c)+ord($kc));
	}
  return $ret;
}

function xor_decrypt_string($content, $key)
{
	$ret = '';
	$strLen = strlen($content);
	$keyLen = strlen($key);
	for ($i=0;$i<$strLen;$i++){
		$c = $content{$i};
		$kc = $key{$i%$keyLen};
		$ret .= chr(ord($c)-ord($kc));
	}
  return $ret;
}

# FILE #######################
function xor_encrypt_file($in_file, $out_file, $key)
{
	$str = file_get_contents($in_file);
	$str = xor_encrypt_string($str, $key);
	return file_put_contents($out_file, $str);
}

function xor_decrypt_file($in_file, $out_file, $key)
{
	$str = file_get_contents($in_file);
	$str = xor_decrypt_string($str, $key);
	return file_put_contents($out_file, $str);
}

?>